# create class like in degrees.py to keep track of moves
class Node():
    def __init__(self, state, parent, action, player, utility, children):
        self.state = []
        self.parent = parent
        self.action = action
        self.player = None
        self.utility = -3
        self.children = [0]

# use queue frontier
class QueueFrontier():
    def __init__(self):
        self.frontier = []

    def add(self, node):
        self.frontier.append(node)

    def contains_state(self, state):
        return any(node.state == state for node in self.frontier)

    def empty(self):
        return len(self.frontier) == 0

    def remove(self):
        if self.empty():
            raise Exception("empty frontier")
        else:
            node = self.frontier[0]
            self.frontier = self.frontier[1:]
            return node
